Description

There are multiple interfaces for tools that handle AdcChannelData. As discussed on p18 of my talk at the April 4 ProtoDUNE
sim/reco meeting (https://indico.fnal.gov/event/16822), there are good reasons to have many many interface classes, but they are
causing some problems. Many tools can be written for a single channel but might be called with a channel map. And there are tools
that view (i.e. do not modify) channel data but that may want to intersperse with tools that update (i.e. do modify) the data.

The situation is made worse by the fact that art tools may be instantiated by DuneToolManager with an invalid interface type (i.e. are
not type safe). This can lead to wrong behavior or obscure crashes when the wrong type of tool is specified in the fcl list of tools. We
should investigate if this can be addressed this at the art or tool manager level, but, for now, mitigate the the problem by reducing the
number interfaces for handling ADC channel data.

We should define a single or small number of interfaces and then modify the current tools to implement these and the clients to use
them.

History

#1 - 04/12/2018 09:15 AM - David Adams

My proposal is to have a single interface for handling AdcChannelData with four methods, each with a default implementation:

update - Updates a single data object and returns a DataMap. Default returns error and logs a warning message.
view - Views a single object. Default calls update with a temporary copy of the data and returns the DataMap f
rom that call.

updateMap - Updates a map of data. Default calls update for each data object in the map and returns a concaten
ated DataMap from those calls.

viewMap - Views a map of data. Default calls view for each data object in the map and returns concatenated Dat
aMaps from those calls.

All methods return a single DataMap and take no additional arguments.
Typical implementations will override one of the above methods but are allowed to override any number.
All methods are const. Stateful tool implementations are allowed but will have to implement a const interface.

This interface class will replace the three classes in dunetpc/dune/Dunelnterface/Tool:

AdcChannelDataModifier.h
AdcChannelViewer.h
AdcDataViewer.h

#2 - 04/12/2018 09:33 AM - Thomas Junk

| agree, this is good work. Asking the art team to make the tool interface type safe sounds reasonable.

But regarding our own code base, I'd like obsolete code to be removed, as it can cause confusion to people
looking for active code, and may inadvertently modify the wrong source file. Or someone can configure their
job to run really old code. | guess it's good for comparisons, but at some point we can move on. Examples
are in CalData (there's a Dual-phase module in there that looks relatively new, but the single-phase stuff is
ancient modules that aren't maintained).

#3 - 04/12/2018 09:37 AM - David Adams

| agree about the obsolete code. But this be tracked in other Redmine issues--not here.

#4 - 04/12/2018 12:32 PM - David Adams

| have put a proposal for the new tool interface at dunetpc/dune/Dunelnterface/Tool/AdcChannelTool.h.
#5 - 04/13/2018 08:55 AM - David Adams
| added #19674 requesting that type checking be added to make_tool.

#6 - 04/15/2018 02:18 PM - David Adams

Tools and service inheriting AdcChannelTool have been modified to instead use AdcChannelData.

#7 - 04/15/2018 03:15 PM - David Adams
The new interface is modified to have methods update and updateMap in place of modify and modifyMap.
Tools and service inheriting AdcChannelDataModifier have been modified to instead use AdcChannelData.

#8 - 04/15/2018 03:41 PM - David Adams

Tools and service inheriting AdcChannelViewer have been modified to instead use AdcChannelData.

This completes the switch to the new interface. Commit c3606ea52195a7caeec004e81bba3f56851eaffb to dunetpc.

| ran single-phase dataprep followed by event displays on one event and the displays look fine.

I will wait for Cl checks before closing this report.

#9 - 08/03/2018 04:19 PM - David Adams

- Status changed from Assigned to Closed

The new tool interface is now standard.
